/*  for
 *  FlexMFS
 *  begun dt 3/6/2000
 *  program to compute stats for variously-shaped MFSs
 *  comments added dt 6/5/2000
 *  started life as MFSIO.h
 *  modified for the IRTScore2s version for 285, September 2004
 */

#if defined(_MSC_VER)
// disable warning C4996: '.' was declared deprecated
// these warnings are an annoying M$ peculiarity
# pragma warning(disable:4996)
#endif

#include <iostream>
#include <string>
#include <sstream>
#include <valarray>
#include <ctime>  // added 12/01 for v. 7? dt
#include "IRT08ss.h"

using namespace std;

void GetControlNums(IRT08ss *test, ostream& OT);			// reads numbers of stages,
															// levels, and pathing info;
															// constructs score tables
void WriteIt (ostream& output, IRT08ss* test); // alt file/console C++ output of score tables

void ScoreA(IRT08ss *test, ostream& OT); // does the response-pattern
										// example score computations
														
void SimB(IRT08ss *test, ostream& OT);
// computes response-pattern EAPs, summed-score EAPs, and MAPs
// based on simulations at fixed theta points

void RandResponse(IRT08ss *test, double theta, int nitems, valarray<int>& x, int s1, int s2);

/* This implements Knuth's Algorithm P (polar method) */
float norm(int s1, int s2);
/* Uniform RNG based on the Marsaglia algorithm */
float unif1(int s1, int s2);

