#ifndef _ITEM_SET08ss_CLASS_
#define _ITEM_SET08ss_CLASS_

// mod dt 2/9/99
// Modified to use valarrays instead of LstArray, 8-2010

#include <iostream>
#include <sstream>   // added 3/98 dt for ReadCol
#include <fstream>	// dt 1/23/99
#include <iomanip>	//
#include <string>
#include <valarray>
#include <vector>
#include "ItemStuf.h"

#define kZeroByte 0
using namespace std;

class IRT08ss {

// A class made up of classes of type ItemStuff, 
// also includes nitem, maxscore, and the name of the parameter file
// mods dt 3/17/00 : Added "next" for MFS sim software, renamed IRT00 from 98
// mods dt 5/2000: added theta_b and se_b, for path-scores as
// theta_b(backwards) = theta^*, the value of theta for which 
//		observed summed score is expected
// mods dt 9/21/04, to become IRT04s; removed much of what's above
// without ReadMlg, support for 3PL is negligible 
// 3PL has been removed entirely
// further simplified 8-2008 for 840

public:

	static int size;

	int nitem;
	int maxscore;
	char DatFile[64];
	ItemStuff* I;  // pointer to an ItemStuff; one for each item

	valarray<double> eap;  
	valarray<double> sd;  
	valarray<double> expd;
	vector < valarray<double> >  lk;  

// from here down are the basic global variables for the Scaled Score App
// Some of this stuff isn't used in the MFS routine, but it's hanging
// around here anyway---dt, 7/98
	static int nqpt;	// quadraure
	static double qpmax;// settings
	int aCol;	// column a is in for columns input
	valarray<int> bColList;  // columns for b's
	
	static valarray<double> theta;  // the theta list
	static valarray<double> popdist;  // the normal ordinates


	IRT08ss();
	~IRT08ss();

	void ChangeNitems(int n);
	void ChangeMaxScore(int m);

	void graded (int i);
// graded: input is the item index number i, telling where in IRT04s this goes;
// as output, it places in test.I[i].T[x] a DblList of each
// trace line's ordinate at each of the values of theta

	void ColItemCtr (char filename[], int& items);
// ColItemCtr counts the number of items
// dt (3/98) modification of MlogItemCtr

	void ReadCol (char filename[], int nitem, int maxcat);
// ReadCol gets the parameter values from a parameters-in-columns file
// for the graded model. There is no exit if error reading file - needs to be added
// dt (3/98) modification of ReadMlog

	void int_stats(valarray<double>& posterior, int score);
// int_stats: close copy of the LISP function of the same name---
// input is a valarray representing posterior likelihood---
// computes EAP, S.D., and P for the posterior

	void int_statsR(valarray<double>& posterior, 
				double& expdvalue, double& eapvalue, double& sdvalue);
// int_statsR--this is a simpler version that just computes the statistics
// and returns them, for use with Demo()

	void recursive ();
// the first 24 lines comprise a close clone of the LISP we did (not)
// publish in the '95 APM article; it's in the Lab text report

	valarray<double> MAP(valarray<int>& x);
// returns MAP and its second-derivative SE for the response pattern x
// partial and new in IRT04s 

private:

};

#endif /* _ITEM_SET08ss_CLASS_ */

