/*
 *  Originatd as a 
 *  program to implement 1-item linear approx scoring method
 *  and response pattern EAPs and MAPs and summed score EAPs
 *  for tests made of 2PL and/or graded items
 *  For now, all items must have same number of categories
 *
 *  Software modified from:
 *  FlexMFS
 *  begun dt 3/6/2000
 *  program to compute stats for variously-shaped MFSs
 *  More modifications for 285, September 2004
 *  Modified to use valarrays instead of LstArray, 8-2010
 *  More mods to remove the linear approximation, and simplify, 8-2010
 */

#include <iostream>
#include <string>
#include "IO.h"
#include "IRT08ss.h"

IRT08ss *test;

int main(void) {
//	char OutFileName[64];
	string OutFileName;
	int choice;
	test = new IRT08ss;

	cout << "IRTScore 840ss: Item Response Theory Scoring" << endl;
	cout << endl << "Enter filename for output [CR for screen output]: " ;
	getline(cin,OutFileName);
	ofstream OT; // output file stream, switchable with cout

	std::ostream & OTref = (OutFileName.size()>0)
	? OT.open(OutFileName.c_str(), std::ios::out), OT
	: std::cout;

	GetControlNums(test, OTref);  // reads item parameters and constructs tables

	cout << "Choose:" << endl
		<< "1 For keyboard entry of item responses" << endl
		<< "2 For simulee-simulation" << endl;
	cin >> choice;
	cin.get();
   											 
	switch (choice) {									
		case 1:
			ScoreA(test, OTref);	// takes response strings and computes estimates
			break;							 
		case 2:
			SimB(test, OTref);		// simulee simulation
			break;
		default:
			cout << "Error; not a valid choice" << endl;
			break;
	}
}